/* Этих typedef'ов хватает для сборки decode.c (ошибка EDG). По-хорошему
 * они должны быть в basics.h, но мы помещаем их сюда, чтобы не портить
 * оригинальные исходники. */
typedef const char a_const_char;
typedef unsigned int uint32_t;

/* ------------------------------------------------------------------------- */

/* FIXME Разобраться, почему так. В таком виде оно досталось в наследство */

/* В decode.c написано, что basics.h должен быть из каталога src (имеется
 * в виду относительно инфраструктуры edg). Но файл basics.h, который лежит
 * рядом, взят из каталога lib_src. Поэтому здесь соберём не хватающие макросы
 * из src/basics.h */

/*
The EDG code can either go into the global namespace or the "edg" namespace.
*/
#define USING_NAMESPACE_EDG

/*
ARG_UNUSED: specifies that the argument that follows may not be used in all
configurations.
*/
#if __has_cpp_attribute(maybe_unused)
#define ARG_UNUSED [[maybe_unused]]
#else /* !(__has_cpp_attribute(maybe_unused)) */
#define ARG_UNUSED __attribute__((unused))
#endif /* __has_cpp_attribute(maybe_unused) */

/*
Define a utility for composing _Pragma string literals.
*/
#define AS_PRAGMA(...) _Pragma(#__VA_ARGS__)

/* Define base macros for silencing GCC warnings.  These do not check GCC
   versions and shouldn't be used directly. */
#define BEGIN_DISABLE_GCC_WARNING(warning) \
  _Pragma("GCC diagnostic push") \
  AS_PRAGMA(GCC diagnostic ignored warning)
#define END_DISABLE_GCC_WARNING \
  _Pragma("GCC diagnostic pop")

/* Define a macro for -Wreturn-local-addr (added in GCC 4.8). */
#define BEGIN_DISABLE_GCC_WARNING_RET_LOCAL_ADDR \
  BEGIN_DISABLE_GCC_WARNING("-Wreturn-local-addr")
#define END_DISABLE_GCC_WARNING_RET_LOCAL_ADDR \
  END_DISABLE_GCC_WARNING
